﻿/**************************************************************************************************
BSD License
The BSD License (http://www.opensource.org/licenses/bsd-license.php) specifies the terms and
conditions of use for FAVideo:

Copyright (c) 2007. Adobe Systems Incorporated.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  • Redistributions of source code must retain the above copyright notice, this list of conditions
    and the following disclaimer.
  • Redistributions in binary form must reproduce the above copyright notice, this list of
    conditions and the following disclaimer in the documentation and/or other materials provided
	with the distribution.
  • Neither the name of Adobe Systems Incorporated nor the names of its contributors may be used
    to endorse or promote products derived from this software without specific prior written
	permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIESOF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


For more information and updates for FAVideo, please visit:
http://www.adobe.com/go/favideo/
**************************************************************************************************/

import com.adobe.favideo.views.BaseView;

class com.adobe.favideo.views.Image extends BaseView {
// Private Properties:
	private var image:MovieClip;
	private var loaded:Boolean;
	private var loader:MovieClipLoader; //Use MovieClipLoader, since UIManager already useses it.
	private var __width:Number;
	private var __height:Number;
	
// Initialization:
	public function Image() { }
	public function onLoad() { configUI(); } 
	
// Public getter / setters:
	public function set visible(value:Boolean):Void {
		_visible = value;
	}
	public function get visible():Boolean {
		return _visible;
	}
	
// Public methods:
	public function load(path:String):Void {
		if (loader == null) { configUI(); }
		clear();
		loader.loadClip(path, image);
		visible = true;
	}
	
	public function clear():Void {
		if (!loader) { configUI(); }
		loader.unloadClip(image);
		loaded = false;
	}
	
	public function setSize(width:Number, height:Number):Void {
		if (loaded) {
			image._width = width;
			image._height = height;
		}
		
		__width = width;
		__height = height;
	}
	
// Private methods:
	
	private function onLoadInit(target:MovieClip):Void {
		loaded = true;
		setSize(__width, __height);
	}
	
	private function configUI():Void {
		loader = new MovieClipLoader();
		loader.addListener(this);
	}
}